#include <avr/interrupt.h>
#include <avr/io.h>

#include <util/delay.h>

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#include <stdlib.h>
#include "lcd.h"

#define UP    0
#define DOWN  1
#define LEFT  2
#define RIGHT 3
#define NONE  5

// directia de miscare (initial spre dreapta)
uint8_t snake_direction;

#define WORLD_WIDTH 50
#define WORLD_HEIGHT 20
#define FOREVER 	1
#define INIT_ROW 	15
#define INIT_COL 	20

//Declaram structuri pentru obstacole,hrana, chenar si sarpe

struct obstacol {
	int x;
	int y;
};
struct hrana {
 	int x;
 	int y;
 };
 struct chenar {
 	int x;
 	int y;
 	char simbol;
 };
 struct sarpe {
 	int x;
 	int y;
 	int lungime;
 	char simbol;
 };
 

/* Setare directii porturi folosite */
/*
void init_buttons(void) {

    DDRB = 0xff;
    PORTB = 0x00;

    // UP
    DDRB &= ~(1 << PB0);
    PORTB |= (1 << PB0);
    
    // LEFT
    DDRB &= ~(1 << PB1);
    PORTB |= (1 << PB1);
    
    // RIGHT
    DDRB &= ~(1 << PB2);
    PORTB |= (1 << PB2);
    
    // DOWN
    DDRB &= ~(1 << PB3);
    PORTB |= (1 << PB3);
    
  
}

*/

/* Verificare butoane apasate */
void check_input(void) {

    // UP
    if (!(PINB & (1 << PB0))) {
        snake_direction = UP;
    }
    
    // LEFT
    if (!(PINB & (1 << PB1))) {
        snake_direction = LEFT;
    }
    
    // RIGHT
    if (!(PINB & (1 << PB2))) {
        snake_direction = RIGHT;
    }
    
    // DOWN
    if (!(PINB & (1 << PB3))) {
        snake_direction = DOWN;
    }
}

void drawBattleship(unsigned char x, unsigned char y)
{
	char i, j;
	
	
	lcd_goto_xy_exact(0,0);
	for(i = 0; i < 5; i++)
		for(j = 0; j < 5; j++)
			
				lcd_setpixel(x + j,y + i);
	
}


/* initializeaza intrarile si iesirile */
void IO_init()
{
    // butoanele sunt puse ca intrare, cu rezistenta de pull-up
    DDRB &= ~((1 << PB0) | (1 << PB1)| (1 << PB2) | (1 << PB3));
    PORTB |= ((1 << PB0) | (1 << PB1)| (1 << PB2) | (1 << PB3));
    
    // intreruperile sunt activate pentru PCINT8 (PB0) si PCINT9 (PB1)
    PCICR  = (1 << PCIE1);
    PCMSK1 = (1 << PCINT8) | (1 << PCINT9) | (1 << PCINT10) | (1 << PCINT11);
}

void drawfood(unsigned char x, unsigned char y){
	char i, j;
	lcd_goto_xy_exact(0,0);
	for( i = 0; i < 3; i++)
		for( j = 0; j < 3; j++)
			lcd_setpixel(x+j, y+i);
}

void drawsnake(struct sarpe* snake, int lungime){
	int i;
	for( i = 0; i < lungime; i++)
	{
		lcd_goto_xy_exact(0,0);
		lcd_setpixel(snake[i].x,snake[i].y);
		lcd_setpixel(snake[i].x + 1,snake[i].y);	
	}
}

void drawborder(){
/*Se initializeaza chenarul*/
	int i;
	for(i=7;i<70;i++){
		
		lcd_setpixel(i,40);
		lcd_setpixel(i,0);
	}
		
	for(i=0;i<=40;i++){
	
		lcd_setpixel(70,i);
		lcd_setpixel(7,i);
	
	}
	
}

int isFoodPositionOk(unsigned char x, unsigned char y, struct sarpe* snake, int lungime){
	int i,j;
	for( i = 0; i < lungime; i++)
		if( x == snake[i].x  || x == snake[i].x + 1 ||  y == snake[i].y)
			return 0;
			
	if( x < 65 && x > 10 &&  y >  5 && y < 35) 
		return 1;
	else
		return 0;
}


int coliziune(struct sarpe* snake, unsigned char x, unsigned char y, int lungime){
	int i,j;
		for( i = 2; i < lungime; i++)
			if( snake[i].x == x && snake[i].y == y)
				return 1;
				
		for(j=7;j<70;j++){
			if(x == j && y==40)
				return 1;
			if(x == j && y==0)
				return 1;
		}
		for(j=0;j<=40;j++){
			if(x ==70 && y==j)
				return 1;
			
			if(x == 7 && y==j)
				return 1;

		}
		
	
	return 0;
}
int main(void)
{
    // initializari si testare interfeta afisare/debug
    IO_init();
	lcd_init();
	lcd_contrast(0x40);

	snake_direction = NONE;
	// Print on first line
	int selectedMode = 0;
	lcd_str("Selectati modul! UP pt.obstacole, DOWN pt. joc normal");
	
	int nrows,score=0, ncols,i,j,x,y,dif,lungime,mod, a=0,var=100,nr=0,oarecare,k;
	char c,m,d,nume[50];
	int ch;
	struct chenar border[100];
	struct sarpe snake[100];
	struct hrana food;
	struct obstacol obs[10];
	
	/*Se initializeaza lungimea sarpelui*/
	lungime=14;
	
	nrows =  LCD_X_RES;
	ncols =  LCD_Y_RES;
	
	while(selectedMode == 0)
	{
        check_input();
        
        // start game
        if (snake_direction == UP)
		{
			m = 'o';
			lcd_clear();
			lcd_str("Joc cu obstacole");
			selectedMode = 1;
		}
		
		if (snake_direction == DOWN)
		{
			m = 'n';
			lcd_clear();
			lcd_str("Joc normal");
			selectedMode = 1;
		}
		   
    
    }
	
	
	char difficulty;
	int difficultySelected = 0;
	if (m == 'o'){
		
		lcd_clear();
		lcd_str("Mod OBSTACOLE.SELECTATI DIFICULATEA:left=HARD   right=EASY");
		while(difficultySelected == 0)
		{	
			check_input();
			if (snake_direction == LEFT)
			{
				difficulty= 'h';
				lcd_clear();
				lcd_str("Joc HARD");
				difficultySelected = 1;
			}
			
			if (snake_direction == RIGHT)
			{
				difficulty = 'e';
				lcd_clear();
				lcd_str("Joc EASY");
				difficultySelected = 1;
			}
		}
		lcd_clear();
 		if(difficulty=='h'){
			
			for(i=0;i<6;i++){
			
				obs[i].x =  (nrows + i * 24) % nrows + i;
				obs[i].y = (ncols + i * 24) % ncols+ 2;
				lcd_goto_xy(obs[i].x,obs[i].y);
				lcd_str("X");
				dif=6;
				
			}
			
		}
		
		if(difficulty=='e'){
			for(i=0;i<3;i++){
				
				obs[i].x = (nrows + i * 24)  % nrows + i;
				obs[i].y = (nrows + i * 24)  % ncols + 2;
				lcd_goto_xy(obs[i].x,obs[i].y);
				lcd_str("X");
				dif=3;
				}
						
		}
			
		mod =1;
		
	}
	
	if (m == 'n') {
		lcd_str("Mod NORMAL.PT A INCEPE, APASATI UN BUTON!");	
	}
	
	snake_direction = NONE;
	int gameStarted = 0;
	
	while(gameStarted == 0)
	{
		check_input();
		if(snake_direction != NONE)
			gameStarted = 1;
	} 
	lcd_clear();
	
	
	/*Se initializeaza chenarul*/
	for(i=7;i<70;i++){
		border[a].x=i;
		border[a].y=7;
		a++;
		
	}
	for(i=7;i<70;i++){
		border[a].x=i;
		border[a].y=7;
		a++;
		
	}
		
	for(i=0;i<=40;i++){
		border[a].x=70;
		border[a].y=i;
		border[a].simbol="-";
		a++;
	}
	for(i=0;i<=40;i++){
		border[a].x=7;
		border[a].y=i;
		border[a].simbol="-";
		a++;
	}
	drawborder();
	
	food.x = rand() % 12 + 8;
	food.y = rand() % 58 + 2;
	
	/*Se genereaza prima hrana*/
	while(isFoodPositionOk(food.x, food.y, snake,lungime) == 0)
	{
		food.x = rand() % 12 + 8;
		food.y = rand() % 58 + 2;
	}
	drawfood(food.x,food.y);
	lcd_update();
	
	// draw initial snake
	snake[0].x=15;
	snake[0].y=24;
	for(i=1;i<lungime;i++) {
		snake[i].x=15;
		snake[i].y=snake[i-1].y-1;
	}
	
	lcd_update();
	int something;
	int foodTaken = 0;
	while(1)
	{
		check_input();
		something = 1;
		//check coliziune
		if(coliziune(snake, snake[0].x, snake[0].y, lungime) == 1)
			break;
		
		if(snake_direction == DOWN){
			lcd_clear();
			for( i = lungime - 1; i > 0; i--)
			{	snake[i].y = snake[i-1].y; 
				snake[i].x = snake[i-1].x;
			}
			snake[0].y = snake[0].y + 1;
			snake[0].x = snake[0].x;
			
			if(foodTaken == 1){
				snake[lungime].x = snake[lungime-1].x;
				snake[lungime].y = snake[lungime -1].y +- 1;
				foodTaken = 0;
				lungime++;
			}
			
			drawsnake(snake, lungime);
			drawfood(food.x,food.y);
			drawborder();
			lcd_update();
			_delay_ms(1000);
		}
		
		if(snake_direction == UP){
			lcd_clear();
			snake[0].y = snake[0].y - 1;
			snake[0].x = snake[0].x;
			
			for( i = lungime - 1; i > 0; i--){	
				snake[i].y = snake[i-1].y; 
				snake[i].x = snake[i-1].x;
			}
			if(foodTaken == 1){
				snake[lungime].x = snake[lungime-1].x;
				snake[lungime].y = snake[lungime -1].y + 1;
				foodTaken = 0;
				lungime++;
			}
			
			drawsnake(snake, lungime);
			drawfood(food.x,food.y);
			drawborder();
			lcd_update();
			_delay_ms(1000);	
		}
		
		if(snake_direction == LEFT){
			lcd_clear();
			snake[0].x = snake[0].x - 1;
			snake[0].y = snake[0].y;
			
			for( i = lungime - 1; i > 0; i--)
			{	snake[i].x = snake[i-1].x; 
				snake[i].y = snake[i-1].y;
			}
			
			if(foodTaken == 1){
				snake[lungime].y = snake[lungime-1].y;
				snake[lungime].x = snake[lungime -1].x + 1;
				foodTaken = 0;
				lungime++;
			}
			drawsnake(snake, lungime);
			drawfood(food.x,food.y);
			drawborder();
			lcd_update();
			_delay_ms(1000);	
		}
	
		if(snake_direction == RIGHT){
			lcd_clear();
			for( i = lungime - 1; i > 0; i--)
			{	snake[i].x= snake[i-1].x; 
				snake[i].y = snake[i-1].y;
			}
			snake[0].x = snake[0].x + 1;
			snake[0].y = snake[0].y;
			
			if(foodTaken == 1){
				snake[lungime].y = snake[lungime-1].y;
				snake[lungime].x = snake[lungime -1].x - 1;
				foodTaken = 0;
				lungime++;
			}
			drawsnake(snake, lungime);
			drawfood(food.x,food.y);
			drawborder();
			lcd_update();
			_delay_ms(1000);
		}
		
		//check food
		for( i = 0; i < 2; i++)
			for( j = 0; j < 2; j++)
				if( snake[lungime-1].x == food.x + i && snake[lungime -1].y == food.y + j )
				{
					foodTaken = 1;
					score ++;
					food.x = rand() % 12 + 8;
					food.y = rand() % 58 + 2;
					while(isFoodPositionOk(food.x, food.y, snake,lungime) == 0)
					{
						food.x = rand() % 12 + 8;
						food.y = rand() % 58 + 2;
					}
				}
	}
	char scor[10];
	itoa(score, scor, 10);
	lcd_clear();
	lcd_str("    GAME OVER    ");
	lcd_str("SCOR: ");
	lcd_str(scor);
	
    return 0;
}

